//+------------------------------------------------------------------+
//|                                            Candle Open Lines.mq4 |
//|                                 Copyright  2010, Jaanus Jantson |
//|                          http://fx.jantson.ee; jaanus@jantson.ee |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Jaanus Jantson"
#property link      "http://fx.jantson.ee; jaanus@jantson.ee"

#property indicator_chart_window

extern bool DrawM15=True;
extern bool DrawD1=true;
extern bool DrawH4=True;
extern bool DrawH1=True;
extern bool DrawW1=True;
extern bool DrawMN1=false;
extern color D1Color=Yellow;
extern int D1Width=2;
extern int D1LocationBar=2;
extern color H4Color=Magenta;
extern int H4Width=2;
extern int H4LocationBar=6;
extern color H1Color=DeepPink;
extern int H1Width=2;
extern int H1LocationBar=9;
extern color M15Color=DeepPink;
extern int M15Width=2;
extern int M15LocationBar=1;
extern color W1Color=Lime;
extern int W1Width=2;
extern int W1LocationBar=13;
extern color MN1Color=Aqua;
extern int MN1Width=2;
extern int MN1LocationBar=17;


double D1Open,H4Open,H1Open,W1Open,MN1Open,M15Open;
datetime D1Time,H4Time,H1Time,W1Time,MN1Time,M15Time,BarLenghtTime,LastDrawTime;


int init(){
   D1Open=iOpen(NULL,PERIOD_D1,0);
   H4Open=iOpen(NULL,PERIOD_H4,0);
   H1Open=iOpen(NULL,PERIOD_H1,0);
   M15Open=iOpen(NULL,PERIOD_M15,0);
   W1Open=iOpen(NULL,PERIOD_W1,0);
   MN1Open=iOpen(NULL,PERIOD_MN1,0);
   D1Time=iTime(NULL,PERIOD_D1,0);
   H4Time=iTime(NULL,PERIOD_H4,0);
   H1Time=iTime(NULL,PERIOD_H1,0);
   M15Time=iTime(NULL,PERIOD_H1,0);
   W1Time=iTime(NULL,PERIOD_W1,0);
   MN1Time=iTime(NULL,PERIOD_MN1,0);
   BarLenghtTime=Time[0]-Time[1];
   if(DrawM15){
      if(ObjectFind("M15")==-1) ObjectCreate("M15",OBJ_TREND,0,0,0,0,0);
      if(ObjectFind("D1Text")==-1) ObjectCreate("M15Text",OBJ_TEXT,0,0,0);
      ObjectSet("M15",OBJPROP_TIME1,D1Time);
      ObjectSet("M15",OBJPROP_PRICE1,D1Open);
      ObjectSet("M15",OBJPROP_TIME2,Time[0]+BarLenghtTime*M15LocationBar);
      ObjectSet("M15",OBJPROP_PRICE2,D1Open);
      ObjectSet("M15",OBJPROP_COLOR,M15Color);
      ObjectSet("M15",OBJPROP_WIDTH,M15Width);
      ObjectSet("M15Text",OBJPROP_TIME1,Time[0]+BarLenghtTime*M15LocationBar);
      ObjectSet("M15Text",OBJPROP_PRICE1,D1Open);
      ObjectSetText("D1Text","1D",10,"Arial Black",M15Color);}
   if(DrawD1){
      if(ObjectFind("D1")==-1) ObjectCreate("D1",OBJ_TREND,0,0,0,0,0);
      if(ObjectFind("D1Text")==-1) ObjectCreate("D1Text",OBJ_TEXT,0,0,0);
      ObjectSet("D1",OBJPROP_TIME1,D1Time);
      ObjectSet("D1",OBJPROP_PRICE1,D1Open);
      ObjectSet("D1",OBJPROP_TIME2,Time[0]+BarLenghtTime*D1LocationBar);
      ObjectSet("D1",OBJPROP_PRICE2,D1Open);
      ObjectSet("D1",OBJPROP_COLOR,D1Color);
      ObjectSet("D1",OBJPROP_WIDTH,D1Width);
      ObjectSet("D1Text",OBJPROP_TIME1,Time[0]+BarLenghtTime*D1LocationBar);
      ObjectSet("D1Text",OBJPROP_PRICE1,D1Open);
      ObjectSetText("D1Text","1D",10,"Arial Black",D1Color);}
   if(DrawH4){
      if(ObjectFind("H4")==-1) ObjectCreate("H4",OBJ_TREND,0,0,0,0,0);
      if(ObjectFind("H4Text")==-1) ObjectCreate("H4Text",OBJ_TEXT,0,0,0);
      ObjectSet("H4",OBJPROP_TIME1,H4Time);
      ObjectSet("H4",OBJPROP_PRICE1,H4Open);
      ObjectSet("H4",OBJPROP_TIME2,Time[0]+BarLenghtTime*H4LocationBar);
      ObjectSet("H4",OBJPROP_PRICE2,H4Open);
      ObjectSet("H4",OBJPROP_COLOR,H4Color);
      ObjectSet("H4",OBJPROP_WIDTH,H4Width);
      ObjectSet("H4Text",OBJPROP_TIME1,Time[0]+BarLenghtTime*H4LocationBar);
      ObjectSet("H4Text",OBJPROP_PRICE1,H4Open);
      ObjectSetText("H4Text","4H",10,"Arial Black",H4Color);}
   if(DrawH1){
      if(ObjectFind("H1")==-1) ObjectCreate("H1",OBJ_TREND,0,0,0,0,0);
      if(ObjectFind("H1Text")==-1) ObjectCreate("H1Text",OBJ_TEXT,0,0,0);
      ObjectSet("H1",OBJPROP_TIME1,H1Time);
      ObjectSet("H1",OBJPROP_PRICE1,H1Open);
      ObjectSet("H1",OBJPROP_TIME2,Time[0]+BarLenghtTime*H1LocationBar);
      ObjectSet("H1",OBJPROP_PRICE2,H1Open);
      ObjectSet("H1",OBJPROP_COLOR,H1Color);
      ObjectSet("H1",OBJPROP_WIDTH,H1Width);
      ObjectSet("H1Text",OBJPROP_TIME1,Time[0]+BarLenghtTime*H1LocationBar);
      ObjectSet("H1Text",OBJPROP_PRICE1,H1Open);
      ObjectSetText("H1Text","1H",10,"Arial Black",H1Color);}
   if(DrawW1){
      if(ObjectFind("W1")==-1) ObjectCreate("W1",OBJ_TREND,0,0,0,0,0);
      if(ObjectFind("W1Text")==-1) ObjectCreate("W1Text",OBJ_TEXT,0,0,0);
      ObjectSet("W1",OBJPROP_TIME1,W1Time);
      ObjectSet("W1",OBJPROP_PRICE1,W1Open);
      ObjectSet("W1",OBJPROP_TIME2,Time[0]+BarLenghtTime*W1LocationBar);
      ObjectSet("W1",OBJPROP_PRICE2,W1Open);
      ObjectSet("W1",OBJPROP_COLOR,W1Color);
      ObjectSet("W1",OBJPROP_WIDTH,W1Width);
      ObjectSet("W1Text",OBJPROP_TIME1,Time[0]+BarLenghtTime*W1LocationBar);
      ObjectSet("W1Text",OBJPROP_PRICE1,W1Open);
      ObjectSetText("W1Text","W1",10,"Arial Black",W1Color);}
   if(DrawMN1){
      if(ObjectFind("MN1")==-1) ObjectCreate("MN1",OBJ_TREND,0,0,0,0,0);
      if(ObjectFind("MN1Text")==-1) ObjectCreate("MN1Text",OBJ_TEXT,0,0,0);
      ObjectSet("MN1",OBJPROP_TIME1,MN1Time);
      ObjectSet("MN1",OBJPROP_PRICE1,MN1Open);
      ObjectSet("MN1",OBJPROP_TIME2,Time[0]+BarLenghtTime*MN1LocationBar);
      ObjectSet("MN1",OBJPROP_PRICE2,MN1Open);
      ObjectSet("MN1",OBJPROP_COLOR,MN1Color);
      ObjectSet("MN1",OBJPROP_WIDTH,MN1Width);
      ObjectSet("MN1Text",OBJPROP_TIME1,Time[0]+BarLenghtTime*MN1LocationBar);
      ObjectSet("MN1Text",OBJPROP_PRICE1,MN1Open);
      ObjectSetText("MN1Text","MN1",10,"Arial Black",MN1Color);}
   LastDrawTime=Time[0];
   return(0);}


int deinit(){
   if(ObjectFind("D1")!=-1) ObjectDelete("D1");
   if(ObjectFind("H4")!=-1) ObjectDelete("H4");
   if(ObjectFind("H1")!=-1) ObjectDelete("H1");
   if(ObjectFind("W1")!=-1) ObjectDelete("W1");
   if(ObjectFind("MN1")!=-1) ObjectDelete("MN1");
   if(ObjectFind("D1Text")!=-1) ObjectDelete("D1Text");
   if(ObjectFind("H4Text")!=-1) ObjectDelete("H4Text");
   if(ObjectFind("H1Text")!=-1) ObjectDelete("H1Text");
   if(ObjectFind("W1Text")!=-1) ObjectDelete("W1Text");
   if(ObjectFind("MN1Text")!=-1) ObjectDelete("MN1Text");
   return(0);}


int start(){
   if(LastDrawTime!=Time[0]){
      D1Open=iOpen(NULL,PERIOD_D1,0);
      H4Open=iOpen(NULL,PERIOD_H4,0);
      H1Open=iOpen(NULL,PERIOD_H1,0);
      M15Open=iOpen(NULL,PERIOD_M15,0);
      W1Open=iOpen(NULL,PERIOD_W1,0);
      MN1Open=iOpen(NULL,PERIOD_MN1,0);
      D1Time=iTime(NULL,PERIOD_D1,0);
      H4Time=iTime(NULL,PERIOD_H4,0);
      H1Time=iTime(NULL,PERIOD_H1,0);
      M15Time=iTime(NULL,PERIOD_M15,0);
      W1Time=iTime(NULL,PERIOD_W1,0);
      MN1Time=iTime(NULL,PERIOD_MN1,0);
      if(DrawM15){
         if(ObjectFind("M15")==-1) ObjectCreate("M15",OBJ_TREND,0,0,0,0,0);
         if(ObjectFind("D1Text")==-1) ObjectCreate("M15Text",OBJ_TEXT,0,0,0);
         ObjectSet("M15",OBJPROP_TIME1,D1Time);
         ObjectSet("M15",OBJPROP_PRICE1,D1Open);
         ObjectSet("M15",OBJPROP_TIME2,Time[0]+BarLenghtTime*M15LocationBar);
         ObjectSet("M15",OBJPROP_PRICE2,D1Open);
         ObjectSet("M15",OBJPROP_COLOR,M15Color);
         ObjectSet("M15",OBJPROP_WIDTH,M15Width);
         ObjectSet("M15Text",OBJPROP_TIME1,Time[0]+BarLenghtTime*M15LocationBar);
         ObjectSet("M15Text",OBJPROP_PRICE1,D1Open);
         ObjectSetText("D1Text","1D",10,"Arial Black",M15Color);}
      if(DrawD1){
         if(ObjectFind("D1")==-1) ObjectCreate("D1",OBJ_TREND,0,0,0,0,0);
         if(ObjectFind("D1Text")==-1) ObjectCreate("D1Text",OBJ_TEXT,0,0,0);
         ObjectSet("D1",OBJPROP_TIME1,D1Time);
         ObjectSet("D1",OBJPROP_PRICE1,D1Open);
         ObjectSet("D1",OBJPROP_TIME2,Time[0]+BarLenghtTime*D1LocationBar);
         ObjectSet("D1",OBJPROP_PRICE2,D1Open);
         ObjectSet("D1",OBJPROP_COLOR,D1Color);
         ObjectSet("D1",OBJPROP_WIDTH,D1Width);
         ObjectSet("D1Text",OBJPROP_TIME1,Time[0]+BarLenghtTime*D1LocationBar);
         ObjectSet("D1Text",OBJPROP_PRICE1,D1Open);
         ObjectSetText("D1Text","1D",10,"Arial Black",D1Color);}
      if(DrawH4){
         if(ObjectFind("H4")==-1) ObjectCreate("H4",OBJ_TREND,0,0,0,0,0);
         if(ObjectFind("H4Text")==-1) ObjectCreate("H4Text",OBJ_TEXT,0,0,0);
         ObjectSet("H4",OBJPROP_TIME1,H4Time);
         ObjectSet("H4",OBJPROP_PRICE1,H4Open);
         ObjectSet("H4",OBJPROP_TIME2,Time[0]+BarLenghtTime*H4LocationBar);
         ObjectSet("H4",OBJPROP_PRICE2,H4Open);
         ObjectSet("H4",OBJPROP_COLOR,H4Color);
         ObjectSet("H4",OBJPROP_WIDTH,H4Width);
         ObjectSet("H4Text",OBJPROP_TIME1,Time[0]+BarLenghtTime*H4LocationBar);
         ObjectSet("H4Text",OBJPROP_PRICE1,H4Open);
         ObjectSetText("H4Text","4H",10,"Arial Black",H4Color);}
      if(DrawH1){
         if(ObjectFind("H1")==-1) ObjectCreate("H1",OBJ_TREND,0,0,0,0,0);
         if(ObjectFind("H1Text")==-1) ObjectCreate("H1Text",OBJ_TEXT,0,0,0);
         ObjectSet("H1",OBJPROP_TIME1,H1Time);
         ObjectSet("H1",OBJPROP_PRICE1,H1Open);
         ObjectSet("H1",OBJPROP_TIME2,Time[0]+BarLenghtTime*H1LocationBar);
         ObjectSet("H1",OBJPROP_PRICE2,H1Open);
         ObjectSet("H1",OBJPROP_COLOR,H1Color);
         ObjectSet("H1",OBJPROP_WIDTH,H1Width);
         ObjectSet("H1Text",OBJPROP_TIME1,Time[0]+BarLenghtTime*H1LocationBar);
         ObjectSet("H1Text",OBJPROP_PRICE1,H1Open);
         ObjectSetText("H1Text","1H",10,"Arial Black",H1Color);}
      if(DrawW1){
         if(ObjectFind("W1")==-1) ObjectCreate("W1",OBJ_TREND,0,0,0,0,0);
         if(ObjectFind("W1Text")==-1) ObjectCreate("W1Text",OBJ_TEXT,0,0,0);
         ObjectSet("W1",OBJPROP_TIME1,W1Time);
         ObjectSet("W1",OBJPROP_PRICE1,W1Open);
         ObjectSet("W1",OBJPROP_TIME2,Time[0]+BarLenghtTime*W1LocationBar);
         ObjectSet("W1",OBJPROP_PRICE2,W1Open);
         ObjectSet("W1",OBJPROP_COLOR,W1Color);
         ObjectSet("W1",OBJPROP_WIDTH,W1Width);
         ObjectSet("W1Text",OBJPROP_TIME1,Time[0]+BarLenghtTime*W1LocationBar);
         ObjectSet("W1Text",OBJPROP_PRICE1,W1Open);
         ObjectSetText("W1Text","W1",10,"Arial Black",W1Color);}
      if(DrawMN1){
         if(ObjectFind("MN1")==-1) ObjectCreate("MN1",OBJ_TREND,0,0,0,0,0);
         if(ObjectFind("MN1Text")==-1) ObjectCreate("MN1Text",OBJ_TEXT,0,0,0);
         ObjectSet("MN1",OBJPROP_TIME1,MN1Time);
         ObjectSet("MN1",OBJPROP_PRICE1,MN1Open);
         ObjectSet("MN1",OBJPROP_TIME2,Time[0]+BarLenghtTime*MN1LocationBar);
         ObjectSet("MN1",OBJPROP_PRICE2,MN1Open);
         ObjectSet("MN1",OBJPROP_COLOR,MN1Color);
         ObjectSet("MN1",OBJPROP_WIDTH,MN1Width);
         ObjectSet("MN1Text",OBJPROP_TIME1,Time[0]+BarLenghtTime*MN1LocationBar);
         ObjectSet("MN1Text",OBJPROP_PRICE1,MN1Open);
         ObjectSetText("MN1Text","MN1",10,"Arial Black",MN1Color);}
      LastDrawTime=Time[0];}
   return(0);}